/*
 *  KEYBOARD SCAN CODE DEFINITIONS
 */

#define UP_ARR  0x148
#define DN_ARR  0x150
#define LF_ARR  0x14B
#define RT_ARR  0x14D
#define HOME	0x147
#define F1		0x13B
#define F2		0x13C
#define F3		0x13D
#define F4		0x13E
#define F5		0x13F
#define F6		0x140
#define F7		0x141
#define F8		0x142
#define F9		0x143
#define F10		0x144
#define CTRL_F1  0x15E
#define CTRL_F2  0x15F
#define CTRL_F3  0x160
#define CTRL_F4  0x161
#define CTRL_F5  0x162
#define CTRL_F6  0x163
#define CTRL_F7  0x164
#define CTRL_F8  0x165
#define CTRL_F9  0x166
#define CTRL_F10 0x167
#define ALT_F1	0x168
#define ALT_F2  0x169
#define ALT_F3	0x16A
#define ALT_F4  0x16B
#define ALT_F5  0x16C
#define ALT_F6  0x16D
#define ALT_F7	0x16E
#define ALT_F8	0x16F
#define ALT_F9  0x170
#define	ALT_F10	0x171
#define CR		13
#define BS		8
#define ESC             27

#include "bios.h"

/*<f>----------------------------------------
 * FUNCTION: <s> int getkey(void)
 * PURPOSE : Gets a key from keyboard
 *         : Waits for input .. so use kbhit() first
 * CREATION: 11/15/1988 07:13:32
 */
int getkey(void)
{
int key,hi,lo;

	key=bioskey(0);
	lo=key & 0x00FF;
	hi=(key & 0xFF00) >> 8;
	return ((lo==0) ? hi+256 : lo);
} /* int getkey(void) */
